// Создается экземпляр пользователського слайдера и передаем в него идентификаторы элементов
var Graph_1 = new Graph("Page 1"); 

//====================================
function Graph(Page)
{   
   var Level = IR.GetItem(Page).GetItem("Item 1"); //определение уровня
   var Graph = IR.GetItem(Page).GetItem("Graph"); //определение графика
   var FillColor = 0xFF0000FF;
   var Width0 = 5;  //рамеры элемента
   var Height0 = 5;
   var X0 = Graph.X;     //начальная точка графика x=0 и y=0
   var Y0 = Graph.Y + Graph.Height - Height0;
   var ElementID = [];  //Массив элементов
   var x = X0;
   var index = 0;
   var indexmax = 100;  //max число точек по оси Х
   var value; // переменные
   var xstep = (Graph.Width - Width0) / indexmax;  //шаг по оси Х в пикселях
   var period = 100; //интервел опроса значений переменной Level
   var maxinputvalue = 100;  //это макс значение входной переменной. Ввести вручную
   var yscale = Graph.Height / maxinputvalue;
   var valuemax = y1 = y2 = 0; 
   
   //Индикаторы
   var xmin = IR.GetItem(Page).GetItem("xmin");
   xmin.X = Graph.X;
   xmin.Y = Graph.Y + Graph.Height;
   var xmax = IR.GetItem(Page).GetItem("xmax"); 
   xmax.X = Graph.X + Graph.Width - xmin.Width;
   xmax.Y = Graph.Y + Graph.Height;
   var ymin = IR.GetItem(Page).GetItem("ymin");
   ymin.X = Graph.X - ymin.Width;
   ymin.Y = Graph.Y + Graph.Height - ymin.Height;
   var ymax = IR.GetItem(Page).GetItem("ymax"); 
   ymax.X = Graph.X - ymax.Width;
   ymax.Y = Graph.Y;
   
   function YMAX(value)
   {
      if(value>=valuemax)
         valuemax = value;
      return valuemax;    
   }
   
   function Create()  // Функция вычисления позиции слайдера относительно уровня
   {
      value = Level.Value; //Получаем значение переменной в этом такте
      value = value.toFixed(); //Округляем
      var dy = Y0 - yscale*value; //Задаем координату сообразно коэф пропорциональности
      var name = "Element " + index;
      var length = ElementID.length;
      
      xmin.Text = "0";
      xmax.Text = index;
      ymin.Text = "0";
      ymax.Text = YMAX(value);
   
      if(index > indexmax)   
      {  
         name = "Element " + (index-1);
         //IR.Log("Создание массива завершено. Длина массива = " + length); 
         IR.DeleteItem(ElementID[0]);
         for(i=0;i<length-1;i++)
         {
            //IR.DeleteItem(IR.GetItem(Page).GetItem("Element 0"));
            ElementID[i] = ElementID[i + 1];
            ElementID[i].Name = "Element " + i;
            ElementID[i].X = X0 + i*xstep;
            //IR.Log(ElementID[i].Name);
         }
         ElementID.splice(length-1,1);
         IR.CreateItem(IR.ITEM_BUTTON,name,x-xstep,dy,Width0,Height0);
         IR.GetItem(Page).GetItem(name).GetState(0).FillColor = FillColor;
         ElementID[length-1] = IR.GetItem(Page).GetItem(name);
         //for(i=0;i<ElementID.length;i++) IR.Log("Элемент массива №" + i + " = " + ElementID[i].Name);
      }
      
      else
      {
         IR.CreateItem(IR.ITEM_BUTTON,name,x,dy,Width0,Height0);
         IR.GetItem(Page).GetItem(name).GetState(0).FillColor = FillColor;
         ElementID[index] = IR.GetItem(Page).GetItem(name);
         index = index + 1;
         x = x + xstep;
         //for(i=0;i<ElementID.length;i++) IR.Log(ElementID[i].Name);
      }
   }
   
   IR.SetInterval(period,Create);
}